//+------------------------------------------------------------------+
//|                                           Custom_Range_Stats.mq4 |
//|                                       Copyright @ Dariusz Surdel |
//|                                   http://www.Fx-NVATC.comeze.com |
//+------------------------------------------------------------------+
#property copyright "Copyright @ Dariusz Surdel"
#property link      "http://www.Fx-NVATC.comeze.com" 
#property indicator_chart_window


//Daily_Range_Stats section:
extern string Custom_Range_Stats__________ = "Custom Range Statistics parameters:" ;

extern bool Show_CR_Stats = true;
extern int Custom_Range_Stats_Tf = 0;
extern bool Auto_Target_Calc_Mode = true;
extern double Auto_Target_Calc_Quot = 0.3;
extern double Common_Sense_MN_Target = 0;
extern double Common_Sense_W1_Target = 0;
extern double Common_Sense_D1_Target = 0;
extern double Common_Sense_H4_Target = 0;
extern double Common_Sense_H1_Target = 0;
int  CR_Stats_DisplayCorner = 2;
int Last_5Tf_y  = 21;
int This_5Tf_y  = 9;
extern int Tf_Label_x  = 80;
extern color CR_Stats_Color = White;
extern string Which_Average_Options_____ = "0 = This5Periods; 1 = Last5Periods";
extern int Which_Average = 1;
extern bool Output_Global_Var = true;
extern bool Show_CR_HL_Lines = false;
extern bool Show_Open_Price = false;
extern color CR_O_Line_Color = Blue;
extern int CR_O_Line_Style = 2;
extern int CR_O_Line_Width = 0;
extern color CR_H_Line_Color = OrangeRed;
extern int CR_H_Line_Style = 0;
extern int CR_H_Line_Width = 2;
extern color CR_L_Line_Color = LimeGreen;
extern int CR_L_Line_Style = 0;
extern int CR_L_Line_Width = 2;
extern bool CR_Lines_Ray = false;
extern bool CR_Lines_Back = true;
extern bool Show_Quadrant_Lines = false;
/* extern int Quadrant_Tf = 1440;*/ 
extern color Quad_H_Line_Color = OrangeRed;
extern int Quad_H_Line_Style = 3;
extern int Quad_H_Line_Width = 0;
extern color Quad_MH_Line_Color = OrangeRed;
extern int Quad_MH_Line_Style = 2;
extern int Quad_MH_Line_Width = 0;
extern color Quad_L_Line_Color = LimeGreen;
extern int Quad_L_Line_Style = 3;
extern int Quad_L_Line_Width = 0;
extern color Quad_ML_Line_Color = LimeGreen;
extern int Quad_ML_Line_Style = 2;
extern int Quad_ML_Line_Width = 0;
extern bool Quad_Lines_Ray = false;
extern bool Quad_Lines_Back = true;

double CR_Tf10,CR_Tf9,CR_Tf8,CR_Tf7,CR_Tf6,
       CR_Tf5,CR_Tf4,CR_Tf3,CR_Tf2,CR_Tf1,
       CR_This_5Weeks,CR_Last_5Weeks,Factor,
       WACR_This_5Weeks,WACR_Last_5Weeks,Current_CR,Common_Sense_Target;
int    Spread;
string text,points;
//----


int init(){
  
// Weekly Range Weekly Stats section:
  if(Custom_Range_Stats_Tf==0) {Custom_Range_Stats_Tf=Period();}      
if(Show_CR_Stats==true&&Period()==Custom_Range_Stats_Tf)
  {
  ObjectCreate("CR_Tf10"+Custom_Range_Stats_Tf, OBJ_LABEL, 0, 0, 0);          // 
  ObjectSet("CR_Tf10"+Custom_Range_Stats_Tf, OBJPROP_CORNER, CR_Stats_DisplayCorner);
  ObjectSet("CR_Tf10"+Custom_Range_Stats_Tf, OBJPROP_XDISTANCE, Tf_Label_x+9);
  ObjectSet("CR_Tf10"+Custom_Range_Stats_Tf, OBJPROP_YDISTANCE, Last_5Tf_y);
  
  ObjectCreate("CR_Tf9"+Custom_Range_Stats_Tf, OBJ_LABEL, 0, 0, 0);
  ObjectSet("CR_Tf9"+Custom_Range_Stats_Tf, OBJPROP_CORNER, CR_Stats_DisplayCorner);  // 
  ObjectSet("CR_Tf9"+Custom_Range_Stats_Tf, OBJPROP_XDISTANCE, Tf_Label_x+50);
  ObjectSet("CR_Tf9"+Custom_Range_Stats_Tf, OBJPROP_YDISTANCE, Last_5Tf_y);
  
  ObjectCreate("CR_Tf8"+Custom_Range_Stats_Tf, OBJ_LABEL, 0, 0, 0);          // 
  ObjectSet("CR_Tf8"+Custom_Range_Stats_Tf, OBJPROP_CORNER, CR_Stats_DisplayCorner);
  ObjectSet("CR_Tf8"+Custom_Range_Stats_Tf, OBJPROP_XDISTANCE, Tf_Label_x+100);
  ObjectSet("CR_Tf8"+Custom_Range_Stats_Tf, OBJPROP_YDISTANCE, Last_5Tf_y);
  
  ObjectCreate("CR_Tf7"+Custom_Range_Stats_Tf, OBJ_LABEL, 0, 0, 0);          // 
  ObjectSet("CR_Tf7"+Custom_Range_Stats_Tf, OBJPROP_CORNER, CR_Stats_DisplayCorner);
  ObjectSet("CR_Tf7"+Custom_Range_Stats_Tf, OBJPROP_XDISTANCE, Tf_Label_x+150);
  ObjectSet("CR_Tf7"+Custom_Range_Stats_Tf, OBJPROP_YDISTANCE, Last_5Tf_y);
  
  ObjectCreate("CR_Tf6"+Custom_Range_Stats_Tf, OBJ_LABEL, 0, 0, 0);          // 
  ObjectSet("CR_Tf6"+Custom_Range_Stats_Tf, OBJPROP_CORNER, CR_Stats_DisplayCorner);
  ObjectSet("CR_Tf6"+Custom_Range_Stats_Tf, OBJPROP_XDISTANCE, Tf_Label_x+200);
  ObjectSet("CR_Tf6"+Custom_Range_Stats_Tf, OBJPROP_YDISTANCE, Last_5Tf_y);
   
  ObjectCreate("CR_Tf5"+Custom_Range_Stats_Tf, OBJ_LABEL, 0, 0, 0);          // 
  ObjectSet("CR_Tf5"+Custom_Range_Stats_Tf, OBJPROP_CORNER, CR_Stats_DisplayCorner);
  ObjectSet("CR_Tf5"+Custom_Range_Stats_Tf, OBJPROP_XDISTANCE, Tf_Label_x+9);
  ObjectSet("CR_Tf5"+Custom_Range_Stats_Tf, OBJPROP_YDISTANCE, This_5Tf_y);
  
  ObjectCreate("CR_Tf4"+Custom_Range_Stats_Tf, OBJ_LABEL, 0, 0, 0);
  ObjectSet("CR_Tf4"+Custom_Range_Stats_Tf, OBJPROP_CORNER, CR_Stats_DisplayCorner);  // 
  ObjectSet("CR_Tf4"+Custom_Range_Stats_Tf, OBJPROP_XDISTANCE, Tf_Label_x+50);
  ObjectSet("CR_Tf4"+Custom_Range_Stats_Tf, OBJPROP_YDISTANCE, This_5Tf_y);
  
  ObjectCreate("CR_Tf3"+Custom_Range_Stats_Tf, OBJ_LABEL, 0, 0, 0);          // 
  ObjectSet("CR_Tf3"+Custom_Range_Stats_Tf, OBJPROP_CORNER, CR_Stats_DisplayCorner);
  ObjectSet("CR_Tf3"+Custom_Range_Stats_Tf, OBJPROP_XDISTANCE, Tf_Label_x+100);
  ObjectSet("CR_Tf3"+Custom_Range_Stats_Tf, OBJPROP_YDISTANCE, This_5Tf_y);
  
  ObjectCreate("CR_Tf2"+Custom_Range_Stats_Tf, OBJ_LABEL, 0, 0, 0);          // 
  ObjectSet("CR_Tf2"+Custom_Range_Stats_Tf, OBJPROP_CORNER, CR_Stats_DisplayCorner);
  ObjectSet("CR_Tf2"+Custom_Range_Stats_Tf, OBJPROP_XDISTANCE, Tf_Label_x+150);
  ObjectSet("CR_Tf2"+Custom_Range_Stats_Tf, OBJPROP_YDISTANCE, This_5Tf_y);
  
  ObjectCreate("CR_Tf1"+Custom_Range_Stats_Tf, OBJ_LABEL, 0, 0, 0);          // 
  ObjectSet("CR_Tf1"+Custom_Range_Stats_Tf, OBJPROP_CORNER, CR_Stats_DisplayCorner);
  ObjectSet("CR_Tf1"+Custom_Range_Stats_Tf, OBJPROP_XDISTANCE, Tf_Label_x+200);
  ObjectSet("CR_Tf1"+Custom_Range_Stats_Tf, OBJPROP_YDISTANCE, This_5Tf_y); 
  
  ObjectCreate("Last 5 "+Custom_Range_Stats_Tf, OBJ_LABEL, 0, 0, 0);          // 
  ObjectSet("Last 5 "+Custom_Range_Stats_Tf, OBJPROP_CORNER, CR_Stats_DisplayCorner);
  ObjectSet("Last 5 "+Custom_Range_Stats_Tf, OBJPROP_XDISTANCE, Tf_Label_x-72);
  ObjectSet("Last 5 "+Custom_Range_Stats_Tf, OBJPROP_YDISTANCE, Last_5Tf_y); 
  ObjectSetText("Last 5 "+Custom_Range_Stats_Tf,"Last 5 "+Custom_Range_Stats_Tf,9, "Berlin Sans FB", CR_Stats_Color);  
  
  ObjectCreate("This 5 "+Custom_Range_Stats_Tf, OBJ_LABEL, 0, 0, 0);          // 
  ObjectSet("This 5 "+Custom_Range_Stats_Tf, OBJPROP_CORNER, CR_Stats_DisplayCorner);
  ObjectSet("This 5 "+Custom_Range_Stats_Tf, OBJPROP_XDISTANCE, Tf_Label_x-72);
  ObjectSet("This 5 "+Custom_Range_Stats_Tf, OBJPROP_YDISTANCE, This_5Tf_y); 
  ObjectSetText("This 5 "+Custom_Range_Stats_Tf,"This 5 "+Custom_Range_Stats_Tf,9, "Berlin Sans FB", CR_Stats_Color);  
  
  ObjectCreate("Custom_Range_Label"+Custom_Range_Stats_Tf, OBJ_LABEL, 0, 0, 0);          // 
  ObjectSet("Custom_Range_Label"+Custom_Range_Stats_Tf, OBJPROP_CORNER, CR_Stats_DisplayCorner);
  ObjectSet("Custom_Range_Label"+Custom_Range_Stats_Tf, OBJPROP_XDISTANCE, Tf_Label_x-72);
  ObjectSet("Custom_Range_Label"+Custom_Range_Stats_Tf, OBJPROP_YDISTANCE, 36); 
  ObjectSetText("Custom_Range_Label"+Custom_Range_Stats_Tf,Custom_Range_Stats_Tf+" Range",9, "Berlin Sans FB", CR_Stats_Color); 
  
  ObjectCreate("Spread_Label"+Custom_Range_Stats_Tf, OBJ_LABEL, 0, 0, 0);          // 
  ObjectSet("Spread_Label"+Custom_Range_Stats_Tf, OBJPROP_CORNER, CR_Stats_DisplayCorner);
  ObjectSet("Spread_Label"+Custom_Range_Stats_Tf, OBJPROP_XDISTANCE, Tf_Label_x-72);
  ObjectSet("Spread_Label"+Custom_Range_Stats_Tf, OBJPROP_YDISTANCE, 54); 
  ObjectSetText("Spread_Label"+Custom_Range_Stats_Tf,"Spread: ",9, "Berlin Sans FB", CR_Stats_Color);  
   
  ObjectCreate("CR_Last_5_"+Custom_Range_Stats_Tf, OBJ_LABEL, 0, 0, 0);          // 
  ObjectSet("CR_Last_5_"+Custom_Range_Stats_Tf, OBJPROP_CORNER, CR_Stats_DisplayCorner);
  ObjectSet("CR_Last_5_"+Custom_Range_Stats_Tf, OBJPROP_XDISTANCE, Tf_Label_x+250);
  ObjectSet("CR_Last_5_"+Custom_Range_Stats_Tf, OBJPROP_YDISTANCE, Last_5Tf_y); 
  
  ObjectCreate("CR_This_5_"+Custom_Range_Stats_Tf, OBJ_LABEL, 0, 0, 0);          // 
  ObjectSet("CR_This_5_"+Custom_Range_Stats_Tf, OBJPROP_CORNER, CR_Stats_DisplayCorner);
  ObjectSet("CR_This_5_"+Custom_Range_Stats_Tf, OBJPROP_XDISTANCE, Tf_Label_x+250);
  ObjectSet("CR_This_5_"+Custom_Range_Stats_Tf, OBJPROP_YDISTANCE, This_5Tf_y); 
  
  ObjectCreate("Sum_Label"+Custom_Range_Stats_Tf, OBJ_LABEL, 0, 0, 0);          // 
  ObjectSet("Sum_Label"+Custom_Range_Stats_Tf, OBJPROP_CORNER, CR_Stats_DisplayCorner);
  ObjectSet("Sum_Label"+Custom_Range_Stats_Tf, OBJPROP_XDISTANCE, Tf_Label_x+250);
  ObjectSet("Sum_Label"+Custom_Range_Stats_Tf, OBJPROP_YDISTANCE, 36); 
  ObjectSetText("Sum_Label"+Custom_Range_Stats_Tf,"Sum",9, "Berlin Sans FB", CR_Stats_Color); 

  ObjectCreate("AR_Last_5_"+Custom_Range_Stats_Tf, OBJ_LABEL, 0, 0, 0);          // 
  ObjectSet("AR_Last_5_"+Custom_Range_Stats_Tf, OBJPROP_CORNER, CR_Stats_DisplayCorner);
  ObjectSet("AR_Last_5_"+Custom_Range_Stats_Tf, OBJPROP_XDISTANCE, Tf_Label_x+300);
  ObjectSet("AR_Last_5_"+Custom_Range_Stats_Tf, OBJPROP_YDISTANCE, Last_5Tf_y); 
  
  ObjectCreate("AR_This_5_"+Custom_Range_Stats_Tf, OBJ_LABEL, 0, 0, 0);          // 
  ObjectSet("AR_This_5_"+Custom_Range_Stats_Tf, OBJPROP_CORNER, CR_Stats_DisplayCorner);
  ObjectSet("AR_This_5_"+Custom_Range_Stats_Tf, OBJPROP_XDISTANCE, Tf_Label_x+300);
  ObjectSet("AR_This_5_"+Custom_Range_Stats_Tf, OBJPROP_YDISTANCE, This_5Tf_y); 
    
  ObjectCreate("CRAR_Label"+Custom_Range_Stats_Tf, OBJ_LABEL, 0, 0, 0);          // 
  ObjectSet("CRAR_Label"+Custom_Range_Stats_Tf, OBJPROP_CORNER, CR_Stats_DisplayCorner);
  ObjectSet("CRAR_Label"+Custom_Range_Stats_Tf, OBJPROP_XDISTANCE, Tf_Label_x+300);
  ObjectSet("CRAR_Label"+Custom_Range_Stats_Tf, OBJPROP_YDISTANCE, 36); 
  ObjectSetText("CRAR_Label"+Custom_Range_Stats_Tf,"A"+Custom_Range_Stats_Tf+"R",9, "Berlin Sans FB", CR_Stats_Color);
  
               ObjectCreate("CustomRange_Open"+Custom_Range_Stats_Tf,OBJ_TREND,0,0,0);
               ObjectSet("CustomRange_Open"+Custom_Range_Stats_Tf,OBJPROP_COLOR,CR_O_Line_Color);
               ObjectSet("CustomRange_Open"+Custom_Range_Stats_Tf,OBJPROP_STYLE,CR_O_Line_Style);
               ObjectSet("CustomRange_Open"+Custom_Range_Stats_Tf,OBJPROP_WIDTH,CR_O_Line_Width);                
               ObjectSet("CustomRange_Open"+Custom_Range_Stats_Tf,OBJPROP_BACK,CR_Lines_Back);              
               ObjectSet("CustomRange_Open"+Custom_Range_Stats_Tf, OBJPROP_RAY, CR_Lines_Ray);
               
               ObjectCreate("CRAR_Pot_High"+Custom_Range_Stats_Tf,OBJ_TREND,0,0,0);
               ObjectSet("CRAR_Pot_High"+Custom_Range_Stats_Tf,OBJPROP_COLOR,CR_H_Line_Color);
               ObjectSet("CRAR_Pot_High"+Custom_Range_Stats_Tf,OBJPROP_STYLE,CR_H_Line_Style);
               ObjectSet("CRAR_Pot_High"+Custom_Range_Stats_Tf,OBJPROP_WIDTH,CR_H_Line_Width);                
               ObjectSet("CRAR_Pot_High"+Custom_Range_Stats_Tf,OBJPROP_BACK,CR_Lines_Back); 
               ObjectSet("CRAR_Pot_High"+Custom_Range_Stats_Tf, OBJPROP_RAY, CR_Lines_Ray);
               
               ObjectCreate("CRAR_Pot_Low"+Custom_Range_Stats_Tf,OBJ_TREND,0,0,0);
               ObjectSet("CRAR_Pot_Low"+Custom_Range_Stats_Tf,OBJPROP_COLOR,CR_L_Line_Color);
               ObjectSet("CRAR_Pot_Low"+Custom_Range_Stats_Tf,OBJPROP_STYLE,CR_L_Line_Style);
               ObjectSet("CRAR_Pot_Low"+Custom_Range_Stats_Tf,OBJPROP_WIDTH,CR_L_Line_Width);                
               ObjectSet("CRAR_Pot_Low"+Custom_Range_Stats_Tf,OBJPROP_BACK,CR_Lines_Back); 
               ObjectSet("CRAR_Pot_Low"+Custom_Range_Stats_Tf, OBJPROP_RAY, CR_Lines_Ray);
                              
               ObjectCreate("Quadrant_Low"+Custom_Range_Stats_Tf,OBJ_TREND,0,0,0);
               ObjectSet("Quadrant_Low"+Custom_Range_Stats_Tf,OBJPROP_COLOR,Quad_L_Line_Color);
               ObjectSet("Quadrant_Low"+Custom_Range_Stats_Tf,OBJPROP_STYLE,Quad_L_Line_Style);
               ObjectSet("Quadrant_Low"+Custom_Range_Stats_Tf,OBJPROP_WIDTH,Quad_L_Line_Width);                
               ObjectSet("Quadrant_Low"+Custom_Range_Stats_Tf,OBJPROP_BACK,Quad_Lines_Back); 
               ObjectSet("Quadrant_Low"+Custom_Range_Stats_Tf, OBJPROP_RAY, Quad_Lines_Ray);
                              
               ObjectCreate("Quadrant_Mid_Low"+Custom_Range_Stats_Tf,OBJ_TREND,0,0,0);
               ObjectSet("Quadrant_Mid_Low"+Custom_Range_Stats_Tf,OBJPROP_COLOR,Quad_ML_Line_Color);
               ObjectSet("Quadrant_Mid_Low"+Custom_Range_Stats_Tf,OBJPROP_STYLE,Quad_ML_Line_Style);
               ObjectSet("Quadrant_Mid_Low"+Custom_Range_Stats_Tf,OBJPROP_WIDTH,Quad_ML_Line_Width);                
               ObjectSet("Quadrant_Mid_Low"+Custom_Range_Stats_Tf,OBJPROP_BACK,Quad_Lines_Back);  
               ObjectSet("Quadrant_Mid_Low"+Custom_Range_Stats_Tf, OBJPROP_RAY, Quad_Lines_Ray);
                              
               ObjectCreate("Quadrant_High"+Custom_Range_Stats_Tf,OBJ_TREND,0,0,0);
               ObjectSet("Quadrant_High"+Custom_Range_Stats_Tf,OBJPROP_COLOR,Quad_H_Line_Color);
               ObjectSet("Quadrant_High"+Custom_Range_Stats_Tf,OBJPROP_STYLE,Quad_H_Line_Style);
               ObjectSet("Quadrant_High"+Custom_Range_Stats_Tf,OBJPROP_WIDTH,Quad_H_Line_Width);                
               ObjectSet("Quadrant_High"+Custom_Range_Stats_Tf,OBJPROP_BACK,Quad_Lines_Back); 
               ObjectSet("Quadrant_High"+Custom_Range_Stats_Tf, OBJPROP_RAY, Quad_Lines_Ray);
                              
               ObjectCreate("Quadrant_Mid_High"+Custom_Range_Stats_Tf,OBJ_TREND,0,0,0);
               ObjectSet("Quadrant_Mid_High"+Custom_Range_Stats_Tf,OBJPROP_COLOR,Quad_MH_Line_Color);
               ObjectSet("Quadrant_Mid_High"+Custom_Range_Stats_Tf,OBJPROP_STYLE,Quad_MH_Line_Style);
               ObjectSet("Quadrant_Mid_High"+Custom_Range_Stats_Tf,OBJPROP_WIDTH,Quad_MH_Line_Width);                
               ObjectSet("Quadrant_Mid_High"+Custom_Range_Stats_Tf,OBJPROP_BACK,Quad_Lines_Back);                               
               ObjectSet("Quadrant_Mid_High"+Custom_Range_Stats_Tf, OBJPROP_RAY, Quad_Lines_Ray);   
               
   }   
//----        
  return(0);

}

int deinit(){
 // Weekly Range Stats section:
 
 for(Custom_Range_Stats_Tf=0; Custom_Range_Stats_Tf<=43200; Custom_Range_Stats_Tf++)
   {
  ObjectDelete("CR_Tf5"+Custom_Range_Stats_Tf);
  ObjectDelete("CR_Tf4"+Custom_Range_Stats_Tf);
  ObjectDelete("CR_Tf3"+Custom_Range_Stats_Tf);
  ObjectDelete("CR_Tf2"+Custom_Range_Stats_Tf);
  ObjectDelete("CR_Tf1"+Custom_Range_Stats_Tf);
  ObjectDelete("CR_Tf10"+Custom_Range_Stats_Tf);
  ObjectDelete("CR_Tf9"+Custom_Range_Stats_Tf);
  ObjectDelete("CR_Tf8"+Custom_Range_Stats_Tf);
  ObjectDelete("CR_Tf7"+Custom_Range_Stats_Tf);
  ObjectDelete("CR_Tf6"+Custom_Range_Stats_Tf);
  ObjectDelete("Last 5 "+Custom_Range_Stats_Tf); 
  ObjectDelete("This 5 "+Custom_Range_Stats_Tf); 
  ObjectDelete("Custom_Range_Label"+Custom_Range_Stats_Tf); 
  ObjectDelete("Sum_Label"+Custom_Range_Stats_Tf);
  ObjectDelete("CRAR_Label"+Custom_Range_Stats_Tf);
  ObjectDelete("CR_This_5_"+Custom_Range_Stats_Tf);
  ObjectDelete("CR_Last_5_"+Custom_Range_Stats_Tf);
  ObjectDelete("Weekly WAWR"+Custom_Range_Stats_Tf);    
  ObjectDelete("AR_This_5_"+Custom_Range_Stats_Tf);
  ObjectDelete("AR_Last_5_"+Custom_Range_Stats_Tf);
  ObjectDelete( "Spread_Label"+Custom_Range_Stats_Tf);
  ObjectDelete("CustomRange_Open"+Custom_Range_Stats_Tf); 
  ObjectDelete("CRAR_Pot_High"+Custom_Range_Stats_Tf);
  ObjectDelete("CRAR_Pot_Low"+Custom_Range_Stats_Tf); 
  ObjectDelete("Quadrant_Low"+Custom_Range_Stats_Tf);
  ObjectDelete("Quadrant_Mid_Low"+Custom_Range_Stats_Tf);
  ObjectDelete("Quadrant_High"+Custom_Range_Stats_Tf);
  ObjectDelete("Quadrant_Mid_High"+Custom_Range_Stats_Tf); 
  ObjectDelete("Trade_Target"+Custom_Range_Stats_Tf);   
    }    
//----
  return(0);
}

int start(){ 

if(Digits==3 || Digits==5)
double vPoint = Point*10; 
   else 
      vPoint = Point;
      
  if(Custom_Range_Stats_Tf==0) {Custom_Range_Stats_Tf=Period();}      
// Weekly Range Weekly Stats section:
if(Show_CR_Stats==true&&Period()==Custom_Range_Stats_Tf)
  {

    
 Spread=NormalizeDouble(MarketInfo(Symbol(),MODE_SPREAD),0);
 if((Digits==5||Digits==3)&&Spread<10) {points="0.";} else points=""; 
 ObjectSetText("Spread_Label"+Custom_Range_Stats_Tf,"Spread: "+points+DoubleToStr(Spread,0),9,"Berlin Sans FB",CR_Stats_Color);
 
 CR_Tf5 = NormalizeDouble((iHigh(NULL,Custom_Range_Stats_Tf,4)-iLow(NULL,Custom_Range_Stats_Tf,4))/Point,Digits);
 CR_Tf4 = NormalizeDouble((iHigh(NULL,Custom_Range_Stats_Tf,3)-iLow(NULL,Custom_Range_Stats_Tf,3))/Point,Digits);
 CR_Tf3 = NormalizeDouble((iHigh(NULL,Custom_Range_Stats_Tf,2)-iLow(NULL,Custom_Range_Stats_Tf,2))/Point,Digits);
 CR_Tf2 = NormalizeDouble((iHigh(NULL,Custom_Range_Stats_Tf,1)-iLow(NULL,Custom_Range_Stats_Tf,1))/Point,Digits);
 CR_Tf1 = NormalizeDouble((iHigh(NULL,Custom_Range_Stats_Tf,0)-iLow(NULL,Custom_Range_Stats_Tf,0))/Point,Digits);
 WACR_This_5Weeks = (CR_Tf5+CR_Tf4+CR_Tf3+CR_Tf2+CR_Tf1)/5;
 
 CR_Tf10 = NormalizeDouble((iHigh(NULL,Custom_Range_Stats_Tf,9)-iLow(NULL,Custom_Range_Stats_Tf,9))/Point,Digits);
 CR_Tf9 = NormalizeDouble((iHigh(NULL,Custom_Range_Stats_Tf,8)-iLow(NULL,Custom_Range_Stats_Tf,8))/Point,Digits);
 CR_Tf8 = NormalizeDouble((iHigh(NULL,Custom_Range_Stats_Tf,7)-iLow(NULL,Custom_Range_Stats_Tf,7))/Point,Digits);
 CR_Tf7 = NormalizeDouble((iHigh(NULL,Custom_Range_Stats_Tf,6)-iLow(NULL,Custom_Range_Stats_Tf,6))/Point,Digits);
 CR_Tf6 = NormalizeDouble((iHigh(NULL,Custom_Range_Stats_Tf,5)-iLow(NULL,Custom_Range_Stats_Tf,5))/Point,Digits);
 WACR_Last_5Weeks = (CR_Tf10+CR_Tf9+CR_Tf8+CR_Tf7+CR_Tf6)/5;
 
 if(Digits==5||Digits==3) {Factor=10;}  else Factor=1;  
  text=DoubleToStr(CR_Tf10/Factor,0);                                                    // 
  ObjectSetText("CR_Tf10"+Custom_Range_Stats_Tf,text,9,"Berlin Sans FB", CR_Stats_Color);
  
  text=DoubleToStr(CR_Tf9/Factor,0);                                                  // 
  ObjectSetText("CR_Tf9"+Custom_Range_Stats_Tf,text,9, "Berlin Sans FB", CR_Stats_Color);
  
  text=DoubleToStr(CR_Tf8/Factor,0);                                                         // 
  ObjectSetText("CR_Tf8"+Custom_Range_Stats_Tf,text,9, "Berlin Sans FB", CR_Stats_Color);  

  text=DoubleToStr(CR_Tf7/Factor,0);                                                         // 
  ObjectSetText("CR_Tf7"+Custom_Range_Stats_Tf,text,9, "Berlin Sans FB", CR_Stats_Color);  
  
  text=DoubleToStr(CR_Tf6/Factor,0);                                                        // 
  ObjectSetText("CR_Tf6"+Custom_Range_Stats_Tf,text,9, "Berlin Sans FB", CR_Stats_Color);
  
  text=DoubleToStr(CR_Tf5/Factor,0);                                                   // 
  ObjectSetText("CR_Tf5"+Custom_Range_Stats_Tf,text,9, "Berlin Sans FB", CR_Stats_Color);
  
  text=DoubleToStr(CR_Tf4/Factor,0);                                                 // 
  ObjectSetText("CR_Tf4"+Custom_Range_Stats_Tf,text,9, "Berlin Sans FB", CR_Stats_Color);
  
  text=DoubleToStr(CR_Tf3/Factor,0);                                                        // 
  ObjectSetText("CR_Tf3"+Custom_Range_Stats_Tf,text,9, "Berlin Sans FB", CR_Stats_Color);  

  text=DoubleToStr(CR_Tf2/Factor,0);                                                       // 
  ObjectSetText("CR_Tf2"+Custom_Range_Stats_Tf,text,9, "Berlin Sans FB", CR_Stats_Color);  
  
  text=DoubleToStr(CR_Tf1/Factor,0);                                                       // 
  ObjectSetText("CR_Tf1"+Custom_Range_Stats_Tf,text,9, "Berlin Sans FB", CR_Stats_Color);
  
  CR_Last_5Weeks=CR_Tf10+CR_Tf9+CR_Tf8+CR_Tf7+CR_Tf6;
  CR_This_5Weeks=CR_Tf5+CR_Tf4+CR_Tf3+CR_Tf2+CR_Tf1;
    
  text=DoubleToStr(CR_This_5Weeks/Factor,0);                                                       // 
  ObjectSetText("CR_This_5_"+Custom_Range_Stats_Tf,text,9, "Berlin Sans FB", CR_Stats_Color); 
  
  text=DoubleToStr(CR_Last_5Weeks/Factor,0);                                                       // 
  ObjectSetText("CR_Last_5_"+Custom_Range_Stats_Tf,text,9, "Berlin Sans FB", CR_Stats_Color);

  text=DoubleToStr(WACR_Last_5Weeks/Factor,0);                                                       // 
  ObjectSetText("AR_Last_5_"+Custom_Range_Stats_Tf,text,9, "Berlin Sans FB", CR_Stats_Color); 
  
  text=DoubleToStr(WACR_This_5Weeks/Factor,0);                                                       // 
  ObjectSetText("AR_This_5_"+Custom_Range_Stats_Tf,text,9, "Berlin Sans FB", CR_Stats_Color);  
  
  ObjectSetText("Custom_Range_Label"+Custom_Range_Stats_Tf,Custom_Range_Stats_Tf+" Range",9, "Berlin Sans FB", CR_Stats_Color); 
  ObjectSetText("CRAR_Label"+Custom_Range_Stats_Tf,"A"+Custom_Range_Stats_Tf+"R",9, "Berlin Sans FB", CR_Stats_Color);


  if(Which_Average == 0) {Current_CR = WACR_This_5Weeks;}
  if(Which_Average == 1) {Current_CR = WACR_Last_5Weeks;}
  
  if(Show_CR_HL_Lines==true)
  {
  
  if(Which_Average == 0) {double Which_Week = WACR_This_5Weeks;}
  if(Which_Average == 1) {       Which_Week = WACR_Last_5Weeks;} 
               
               ObjectSet("WHL"+Custom_Range_Stats_Tf, OBJPROP_TIME1, Time[0]);
               ObjectSet("WHL"+Custom_Range_Stats_Tf, OBJPROP_PRICE1, iLow(NULL,Custom_Range_Stats_Tf,0)+Which_Week/Factor*vPoint);
               
               ObjectSet("WLL"+Custom_Range_Stats_Tf, OBJPROP_TIME1, Time[0]);
               ObjectSet("WLL"+Custom_Range_Stats_Tf, OBJPROP_PRICE1, iHigh(NULL,Custom_Range_Stats_Tf,0)-Which_Week/Factor*vPoint);
    if(Show_Open_Price==true)
      {           
               ObjectSet("CustomRange_Open"+Custom_Range_Stats_Tf, OBJPROP_TIME1, iTime(Symbol(),Custom_Range_Stats_Tf,Bars));
               ObjectSet("CustomRange_Open"+Custom_Range_Stats_Tf, OBJPROP_TIME2, iTime(Symbol(),0,0)+Custom_Range_Stats_Tf);
               ObjectSet("CustomRange_Open"+Custom_Range_Stats_Tf, OBJPROP_PRICE1, iOpen(NULL,Custom_Range_Stats_Tf,0));
               ObjectSet("CustomRange_Open"+Custom_Range_Stats_Tf, OBJPROP_PRICE2, iOpen(NULL,Custom_Range_Stats_Tf,0));
      }       
               ObjectSet("CRAR_Pot_High"+Custom_Range_Stats_Tf, OBJPROP_TIME1, iTime(Symbol(),Custom_Range_Stats_Tf,Bars));
               ObjectSet("CRAR_Pot_High"+Custom_Range_Stats_Tf, OBJPROP_TIME2, iTime(Symbol(),0,0)+Custom_Range_Stats_Tf);
               ObjectSet("CRAR_Pot_High"+Custom_Range_Stats_Tf, OBJPROP_PRICE1, iLow(NULL,Custom_Range_Stats_Tf,0)+Which_Week/Factor*vPoint);
               ObjectSet("CRAR_Pot_High"+Custom_Range_Stats_Tf, OBJPROP_PRICE2, iLow(NULL,Custom_Range_Stats_Tf,0)+Which_Week/Factor*vPoint);
               
               ObjectSet("CRAR_Pot_Low"+Custom_Range_Stats_Tf, OBJPROP_TIME1, iTime(Symbol(),Custom_Range_Stats_Tf,Bars));
               ObjectSet("CRAR_Pot_Low"+Custom_Range_Stats_Tf, OBJPROP_TIME2, iTime(Symbol(),0,0)+Custom_Range_Stats_Tf);
               ObjectSet("CRAR_Pot_Low"+Custom_Range_Stats_Tf, OBJPROP_PRICE1, iHigh(NULL,Custom_Range_Stats_Tf,0)-Which_Week/Factor*vPoint);
               ObjectSet("CRAR_Pot_Low"+Custom_Range_Stats_Tf, OBJPROP_PRICE2, iHigh(NULL,Custom_Range_Stats_Tf,0)-Which_Week/Factor*vPoint);
               ObjectSetText("CRAR_Pot_Low"+Custom_Range_Stats_Tf,DoubleToStr(Current_CR,0),9, "Berlin Sans FB", CR_Stats_Color);  
              
  }
  
if(Show_Quadrant_Lines==true)
  {
  if(Which_Average == 0) {       Which_Week = WACR_This_5Weeks;}
  if(Which_Average == 1) {       Which_Week = WACR_Last_5Weeks;} 
    
               ObjectSet("Quadrant_High"+Custom_Range_Stats_Tf, OBJPROP_TIME1, iTime(Symbol(),Custom_Range_Stats_Tf,Bars));
               ObjectSet("Quadrant_High"+Custom_Range_Stats_Tf, OBJPROP_TIME2, iTime(Symbol(),0,0)+Custom_Range_Stats_Tf);
               ObjectSet("Quadrant_High"+Custom_Range_Stats_Tf, OBJPROP_PRICE1, iOpen(NULL,Custom_Range_Stats_Tf,0)+Which_Week/Factor*vPoint);
               ObjectSet("Quadrant_High"+Custom_Range_Stats_Tf, OBJPROP_PRICE2, iOpen(NULL,Custom_Range_Stats_Tf,0)+Which_Week/Factor*vPoint);  
                 
               ObjectSet("Quadrant_Mid_High"+Custom_Range_Stats_Tf, OBJPROP_TIME1, iTime(Symbol(),Custom_Range_Stats_Tf,Bars));
               ObjectSet("Quadrant_Mid_High"+Custom_Range_Stats_Tf, OBJPROP_TIME2, iTime(Symbol(),0,0)+Custom_Range_Stats_Tf);
               ObjectSet("Quadrant_Mid_High"+Custom_Range_Stats_Tf, OBJPROP_PRICE1, iOpen(NULL,Custom_Range_Stats_Tf,0)+Which_Week/Factor*vPoint/2);
               ObjectSet("Quadrant_Mid_High"+Custom_Range_Stats_Tf, OBJPROP_PRICE2, iOpen(NULL,Custom_Range_Stats_Tf,0)+Which_Week/Factor*vPoint/2); 
    if(Show_Open_Price==true)
      {                               
               ObjectSet("CustomRange_Open"+Custom_Range_Stats_Tf, OBJPROP_TIME1, iTime(Symbol(),Custom_Range_Stats_Tf,Bars));
               ObjectSet("CustomRange_Open"+Custom_Range_Stats_Tf, OBJPROP_TIME2, iTime(Symbol(),0,0)+Custom_Range_Stats_Tf);
               ObjectSet("CustomRange_Open"+Custom_Range_Stats_Tf, OBJPROP_PRICE1, iOpen(NULL,Custom_Range_Stats_Tf,0));
               ObjectSet("CustomRange_Open"+Custom_Range_Stats_Tf, OBJPROP_PRICE2, iOpen(NULL,Custom_Range_Stats_Tf,0));
      }
               ObjectSet("Quadrant_Mid_Low"+Custom_Range_Stats_Tf, OBJPROP_TIME1, iTime(Symbol(),Custom_Range_Stats_Tf,Bars));
               ObjectSet("Quadrant_Mid_Low"+Custom_Range_Stats_Tf, OBJPROP_TIME2, iTime(Symbol(),0,0)+Custom_Range_Stats_Tf);
               ObjectSet("Quadrant_Mid_Low"+Custom_Range_Stats_Tf, OBJPROP_PRICE1, iOpen(NULL,Custom_Range_Stats_Tf,0)-Which_Week/Factor*vPoint/2);
               ObjectSet("Quadrant_Mid_Low"+Custom_Range_Stats_Tf, OBJPROP_PRICE2, iOpen(NULL,Custom_Range_Stats_Tf,0)-Which_Week/Factor*vPoint/2); 
                              
               ObjectSet("Quadrant_Low"+Custom_Range_Stats_Tf, OBJPROP_TIME1, iTime(Symbol(),Custom_Range_Stats_Tf,Bars));
               ObjectSet("Quadrant_Low"+Custom_Range_Stats_Tf, OBJPROP_TIME2, iTime(Symbol(),0,0)+Custom_Range_Stats_Tf);
               ObjectSet("Quadrant_Low"+Custom_Range_Stats_Tf, OBJPROP_PRICE1, iOpen(NULL,Custom_Range_Stats_Tf,0)-Which_Week/Factor*vPoint);
               ObjectSet("Quadrant_Low"+Custom_Range_Stats_Tf, OBJPROP_PRICE2, iOpen(NULL,Custom_Range_Stats_Tf,0)-Which_Week/Factor*vPoint);
                                               
  }                
//----
if(Period()==43200) {Common_Sense_Target=Common_Sense_MN_Target;} 
if(Period()==10080) {Common_Sense_Target=Common_Sense_W1_Target;} 
if(Period()==1440) {Common_Sense_Target=Common_Sense_D1_Target;} 
if(Period()==240) {Common_Sense_Target=Common_Sense_H4_Target;}
if(Period()==60) {Common_Sense_Target=Common_Sense_H1_Target;}  

if(Auto_Target_Calc_Mode == true)
  { 
  if(Which_Average == 0) { Which_Week = WACR_This_5Weeks;}
  if(Which_Average == 1) { Which_Week = WACR_Last_5Weeks;}   
  
  Common_Sense_Target=Auto_Target_Calc_Quot*Which_Week;
  }
  
  ObjectCreate("Trade_Target"+Custom_Range_Stats_Tf, OBJ_LABEL, 0, 0, 0);          // 
  ObjectSet("Trade_Target"+Custom_Range_Stats_Tf, OBJPROP_CORNER, CR_Stats_DisplayCorner);
  ObjectSet("Trade_Target"+Custom_Range_Stats_Tf, OBJPROP_XDISTANCE, Tf_Label_x+80);
  ObjectSet("Trade_Target"+Custom_Range_Stats_Tf, OBJPROP_YDISTANCE, 36);           
  ObjectSetText("Trade_Target"+Custom_Range_Stats_Tf,"Target: "+DoubleToStr(Common_Sense_Target,0)+" Pips",9, "Berlin Sans FB", CR_Stats_Color);

  if(Output_Global_Var==true) {GlobalVariableSet("Global_Target"+Symbol(),Common_Sense_Target);}
   
  }
//----

        
  return(0);
   
}
//+------------------------------------------------------------------+